''Chris Joens
''Research project

CON
  _clkmode      = xtal1 + pll16x
  _xinfreq      = 5_000_000
  LCD_Pin       = 0                    'The LCD is connected to pin A0.
  LCD_Baud      = 19_200               'Baud
  LCD_Lines     = 4                    'The number of lines on this LCD
  Off           = 0
  On            = 1
  PacketLength  = 10                   'Total Number BYTES in polynomial CRC packet
  TXpin1        = 2                   'Connected to Parallax Transmiter
  RXpin1        = 1                  'Connected to Parallax Reciver
  FIFOBufferSize = 16         
  
OBJ
  Debug:  "FullDuplexSerialPlus"
  LCD:    "debug_lcd"                        'Creates the object LCD from "debug_lcd"
  RF:     "RF_Transceiver"     
VAR
  byte  StringBuffer[FIFOBufferSize],Null
  long  ErrorCounter,ValidCounter

 
PUB Start  

               
      'Send messages stored in the DAT block.
      'Initialize things------------------------------------
        
       Debug.start(31, 30, 0, 57600)
       waitcnt(clkfreq*2 + cnt)

  if lcd.init(LCD_PIN, LCD_BAUD, LCD_LINES)             ' start lcd
      lcd.cursor(0)                                       ' cursor off
      lcd.backLight(true)                                 ' backlight on (if available)
      lcd.custom(0, @Bullet)                              ' create custom character 0
      lcd.cls                                             ' clear the lcd
      lcd.str(string(" WSN", 13))
      lcd.putc(0)                                         ' display custom bullet character
      lcd.str(string("Error", 13))
      lcd.putc(0)
      lcd.str(string("Data", 13)) 
      lcd.putc(0)
      lcd.str(string("Sensor"))

   ' finish the Initialize of devices--------------------
  repeat
     Send

     waitcnt(clkfreq + cnt)
PUB Count| value, counter
     lcd.gotoxy(10, 0)      
     lcd.Str(@MyString)
     lcd.Dec(counter++)

PUB Send|Index  
    RF.Initialize(PacketLength)                         

    DEBUG.start(31, 30, 0, 38400)                       '' Initialize serial COMM to PC

    repeat
      RF.Receive

      DEBUG.tx(1)                                       '' Position cursor at the Home position

      repeat Index from 0 to 9                          '' Display Transmitted DATA
        DEBUG.dec(RF.GetRX(Index))
        DEBUG.str(string("  "))
        DEBUG.tx(13)



PUB ReceiveLOGIC
    RF.Initialize(PacketLength)

    repeat
                                                                                
      RF.PutTX(0,Num++  & $FF)
      RF.PutTX(1,Num>>1 & $FF)
      RF.PutTX(2,Num>>2 & $FF)
      RF.PutTX(3,Num>>3 & $FF)
      RF.PutTX(4,40)
      RF.PutTX(5,50)
      RF.PutTX(6,65)
      RF.PutTX(7,70)
      RF.PutTX(8,80)
      RF.PutTX(9,90)

      RF.Send


PUB Serial_FIFO
    bytemove(@StringBuffer[0],@StringBuffer[1],FIFOBufferSize-1)
    StringBuffer[15] := Debug.rx

PUB Command(Compare)|_Length
    _Length := StrSize(Compare)
    if StrComp(Compare,@StringBuffer[FIFOBufferSize-_Length])
       result := 1
    else
       result := 0
    
DAT
  Bullet          byte     $00, $04, $0E, $1F, $0E, $04, $00, $00
  MyString        byte     "Run CNT", 0
  testStr         byte     " I Made it" ,0
  BlankLine       byte      Debug#CR, Debug#CR, 0
  Num     long  0        